<?php
namespace Bushelpowered\Api\Finops\Aggregator\V1\Responses;
        
class LenderDetails 
{
    /** @var string $name The unique name for a specific configuration of a lender (if CFA has multiple APIs each would have its own 'lender' with a unique name.*/
    public string $name;
    /** @var \Bushelpowered\Api\Finops\Aggregator\V1\Responses\TermItem[] $termsAndConditions The list of terms and conditions for this lender.*/
    public array $termsAndConditions;
    /** @var \Bushelpowered\Api\Finops\Aggregator\V1\Responses\GetAllLendersDealerListItem[] $dealers The dealers for this lender.*/
    public array $dealers;

    /**
     * @param  string  $name The unique name for a specific configuration of a lender (if CFA has multiple APIs each would have its own 'lender' with a unique name.
     * @param  \Bushelpowered\Api\Finops\Aggregator\V1\Responses\TermItem[]  $termsAndConditions The list of terms and conditions for this lender.
     * @param  \Bushelpowered\Api\Finops\Aggregator\V1\Responses\GetAllLendersDealerListItem[]  $dealers The dealers for this lender.
     */
    public function __construct(string $name, array $termsAndConditions, array $dealers)
    {
        $this->name = $name;
        $this->termsAndConditions = $termsAndConditions;
        $this->dealers = $dealers;
    }
    

}