<?php
namespace Bushelpowered\Api\Grain\Contracts\V1\Request;
        
class ContractPagination implements \Bushelpowered\Api\Common\PaginationBase
{
    /** @var \Bushelpowered\Api\Grain\Contracts\V1\Request\ContractSortPlan[]|null $sortPlan List of column and sort direction*/
    public ?array $sortPlan = null;
    /** @var null|\Bushelpowered\Api\Grain\Contracts\V1\Request\ContractSortSchemes $sortScheme */
    public ?\Bushelpowered\Api\Grain\Contracts\V1\Request\ContractSortSchemes $sortScheme = null;
    /** @var null|string $token A continuation token.*/
    public ?string $token = null;
    /** @var null|int $pageSize The desired size of pages, subject to service-imposed limitations.*/
    public ?int $pageSize = null;

    /**
     * @param  \Bushelpowered\Api\Grain\Contracts\V1\Request\ContractSortPlan[]|null  $sortPlan List of column and sort direction
     * @param  null|\Bushelpowered\Api\Grain\Contracts\V1\Request\ContractSortSchemes  $sortScheme 
     * @param  null|string  $token A continuation token.
     * @param  null|int  $pageSize The desired size of pages, subject to service-imposed limitations.
     */
    public function __construct(?array $sortPlan, ?\Bushelpowered\Api\Grain\Contracts\V1\Request\ContractSortSchemes $sortScheme, ?string $token, ?int $pageSize)
    {
        $this->sortPlan = $sortPlan;
        $this->sortScheme = $sortScheme;
        $this->token = $token;
        $this->pageSize = $pageSize;
    }
    
    /**
     * @return null|string A continuation token.
     */
    public function getToken(): ?string
    {
        return $this->token;
    }
    /**
     * @return null|int The desired size of pages, subject to service-imposed limitations.
     */
    public function getPageSize(): ?int
    {
        return $this->pageSize;
    }
}