<?php
namespace Bushelpowered\Api\Iam\Serviceaccounts\V1\Model;
        
class ServiceAccountKeyDetails implements \Bushelpowered\Api\Common\HasCreatedBy, \Bushelpowered\Api\Common\HasTimestamps
{
    /** @var string $id The id of the service account key*/
    public string $id;
    /** @var string $tenantId The tenant id that owns the service account key*/
    public string $tenantId;
    /** @var string $serviceAccountId The id of the service account*/
    public string $serviceAccountId;
    /** @var string $name The name of the key*/
    public string $name;
    /** @var string $expiresAt The the instant the key expires of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $expiresAt;
    /** @var string $createdBy Created by UUID within the microservice.*/
    public string $createdBy;
    /** @var string $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;
    /** @var null|string $deletedAt Deleted date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $deletedAt = null;

    /**
     * @param  string  $id The id of the service account key
     * @param  string  $tenantId The tenant id that owns the service account key
     * @param  string  $serviceAccountId The id of the service account
     * @param  string  $name The name of the key
     * @param  string  $expiresAt The the instant the key expires of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $createdBy Created by UUID within the microservice.
     * @param  string  $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $deletedAt Deleted date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, string $tenantId, string $serviceAccountId, string $name, string $expiresAt, string $createdBy, string $createdAt, string $updatedAt, ?string $deletedAt)
    {
        $this->id = $id;
        $this->tenantId = $tenantId;
        $this->serviceAccountId = $serviceAccountId;
        $this->name = $name;
        $this->expiresAt = $expiresAt;
        $this->createdBy = $createdBy;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
        $this->deletedAt = $deletedAt;
    }
    
    /**
     * @return string Created by UUID within the microservice.
     */
    public function getCreatedBy(): string
    {
        return $this->createdBy;
    }
    /**
     * @return string Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
    /**
     * @return null|string Deleted date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getDeletedAt(): ?string
    {
        return $this->deletedAt;
    }
}