<?php
namespace Bushelpowered\Api\Markets\Aggregator\Bids\V1\Response;
        
class BidsListBid 
{
    /** @var string $id */
    public string $id;
    /** @var \Bushelpowered\Api\Markets\Aggregator\Bids\V1\Model\BidType $bidType */
    public \Bushelpowered\Api\Markets\Aggregator\Bids\V1\Model\BidType $bidType;
    /** @var string $description */
    public string $description;
    /** @var string $deliveryStart  of yyyy-MM-dd format, IE: 2023-10-04*/
    public string $deliveryStart;
    /** @var string $deliveryEnd  of yyyy-MM-dd format, IE: 2023-10-04*/
    public string $deliveryEnd;
    /** @var null|string $bidPrice  arbitrary precision number format, IE 3.55618381*/
    public ?string $bidPrice = null;
    /** @var null|string $basisPrice  arbitrary precision number format, IE 3.55618381*/
    public ?string $basisPrice = null;
    /** @var null|string $futuresPrice  arbitrary precision number format, IE 3.55618381*/
    public ?string $futuresPrice = null;
    /** @var null|string $futuresChange  arbitrary precision number format, IE 3.55618381*/
    public ?string $futuresChange = null;
    /** @var null|int $futuresChangeSign */
    public ?int $futuresChangeSign = null;
    /** @var null|string $futuresSymbol */
    public ?string $futuresSymbol = null;
    /** @var \Bushelpowered\Api\Markets\Aggregator\Bids\V1\Response\BidsListBidOperations $operations */
    public \Bushelpowered\Api\Markets\Aggregator\Bids\V1\Response\BidsListBidOperations $operations;

    /**
     * @param  string  $id 
     * @param  \Bushelpowered\Api\Markets\Aggregator\Bids\V1\Model\BidType  $bidType 
     * @param  string  $description 
     * @param  string  $deliveryStart  of yyyy-MM-dd format, IE: 2023-10-04
     * @param  string  $deliveryEnd  of yyyy-MM-dd format, IE: 2023-10-04
     * @param  null|string  $bidPrice  arbitrary precision number format, IE 3.55618381
     * @param  null|string  $basisPrice  arbitrary precision number format, IE 3.55618381
     * @param  null|string  $futuresPrice  arbitrary precision number format, IE 3.55618381
     * @param  null|string  $futuresChange  arbitrary precision number format, IE 3.55618381
     * @param  null|int  $futuresChangeSign 
     * @param  null|string  $futuresSymbol 
     * @param  \Bushelpowered\Api\Markets\Aggregator\Bids\V1\Response\BidsListBidOperations  $operations 
     */
    public function __construct(string $id, \Bushelpowered\Api\Markets\Aggregator\Bids\V1\Model\BidType $bidType, string $description, string $deliveryStart, string $deliveryEnd, ?string $bidPrice, ?string $basisPrice, ?string $futuresPrice, ?string $futuresChange, ?int $futuresChangeSign, ?string $futuresSymbol, \Bushelpowered\Api\Markets\Aggregator\Bids\V1\Response\BidsListBidOperations $operations)
    {
        $this->id = $id;
        $this->bidType = $bidType;
        $this->description = $description;
        $this->deliveryStart = $deliveryStart;
        $this->deliveryEnd = $deliveryEnd;
        $this->bidPrice = $bidPrice;
        $this->basisPrice = $basisPrice;
        $this->futuresPrice = $futuresPrice;
        $this->futuresChange = $futuresChange;
        $this->futuresChangeSign = $futuresChangeSign;
        $this->futuresSymbol = $futuresSymbol;
        $this->operations = $operations;
    }
    

}