<?php

namespace Bushelpowered\Api\Platform\File\V1\Common;

class Format
{
    public string $type;
    public $data;
    private \JsonMapper $mapper;

    private static $types = [
        'jpeg' => '\Bushelpowered\Api\Platform\File\V1\Common\JPEGFormat',
        'png' => '\Bushelpowered\Api\Platform\File\V1\Common\PNGFormat',
        'webp' => '\Bushelpowered\Api\Platform\File\V1\Common\WebPFormat',
    ];

    private function __construct($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function Jpeg(\Bushelpowered\Api\Platform\File\V1\Common\JPEGFormat $data): Format
    {
        return new Format('jpeg', $data);
    }
    public static function Png(\Bushelpowered\Api\Platform\File\V1\Common\PNGFormat $data): Format
    {
        return new Format('png', $data);
    }
    public static function Webp(\Bushelpowered\Api\Platform\File\V1\Common\WebPFormat $data): Format
    {
        return new Format('webp', $data);
    }

    public function getData() {
        $className = self::$types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    