<?php
namespace Bushelpowered\Api\Quoting\V1\Request;
        
class UpsertServiceRequest 
{
    /** @var null|string $id The id of the record to update, will be created if null*/
    public ?string $id = null;
    /** @var \Bushelpowered\Api\Quoting\V1\Enums\ServiceType $serviceType */
    public \Bushelpowered\Api\Quoting\V1\Enums\ServiceType $serviceType;
    /** @var string $description */
    public string $description;
    /** @var null|string $requestedServiceDate The requested service date of yyyy-MM-dd format, IE: 2023-10-04*/
    public ?string $requestedServiceDate = null;

    /**
     * @param  null|string  $id The id of the record to update, will be created if null
     * @param  \Bushelpowered\Api\Quoting\V1\Enums\ServiceType  $serviceType 
     * @param  string  $description 
     * @param  null|string  $requestedServiceDate The requested service date of yyyy-MM-dd format, IE: 2023-10-04
     */
    public function __construct(?string $id, \Bushelpowered\Api\Quoting\V1\Enums\ServiceType $serviceType, string $description, ?string $requestedServiceDate)
    {
        $this->id = $id;
        $this->serviceType = $serviceType;
        $this->description = $description;
        $this->requestedServiceDate = $requestedServiceDate;
    }
    

}