<?php
namespace Bushelpowered\Api\Trade\Config\V1\Operation;

use \Bushelpowered\Api\Trade\Config\V1\Request\NullableUUIDRequest;
use \Bushelpowered\Api\Trade\Config\V1\Response\SalesSeriesConfigurationResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bidl\Php\Core\Builtins\UnknownError;

class FindOrCreateSalesSeriesConfiguration 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    /**
     * @deprecated use request instead.
     */
    public function call(NullableUUIDRequest $request, $headers): SalesSeriesConfigurationResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/trade/config/v1/operation/FindOrCreateSalesSeriesConfiguration', $request, $this->getWrapper(), $headers);
    }
    
    public function request(NullableUUIDRequest $request, FindOrCreateSalesSeriesConfigurationMetadata $hasHeaders): SalesSeriesConfigurationResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/trade/config/v1/operation/FindOrCreateSalesSeriesConfiguration', $request, $this->getWrapper(), $hasHeaders->getMetaData());
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var SalesSeriesConfigurationResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.trade.config.v1.operation#FindOrCreateSalesSeriesConfigurationSuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Trade\Config\V1\Response\SalesSeriesConfigurationResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#BadRequest':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthenticated':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthorized':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}