<?php
namespace Bushelpowered\Api\Trade\Esign\V1\Request;
        
class CreateDocumentRequest implements \Bushelpowered\Api\Trade\Esign\V1\Request\EncodedPdf
{
    /** @var null|string $name The name of the Contract, shown to the grower user.*/
    public ?string $name = null;
    /** @var string $datasourceId The id of the datasource where this record came from.*/
    public string $datasourceId;
    /** @var bool $isSigned Whether or not the document is signed by the creator.*/
    public bool $isSigned;
    /** @var string $file The PDF of the document base64 encoded.*/
    public string $file;

    /**
     * @param  null|string  $name The name of the Contract, shown to the grower user.
     * @param  string  $datasourceId The id of the datasource where this record came from.
     * @param  bool  $isSigned Whether or not the document is signed by the creator.
     * @param  string  $file The PDF of the document base64 encoded.
     */
    public function __construct(?string $name, string $datasourceId, bool $isSigned, string $file)
    {
        $this->name = $name;
        $this->datasourceId = $datasourceId;
        $this->isSigned = $isSigned;
        $this->file = $file;
    }
    
    /**
     * @return string The PDF of the document base64 encoded.
     */
    public function getFile(): string
    {
        return $this->file;
    }
}