<?php
namespace Bushelpowered\Api\Trade\Esign\V1\Response;
        
class EsignListResponse implements \Bushelpowered\Api\Common\ReturnsPaginationTokens
{
    /** @var string $documentId The Esign Service's Document Id.*/
    public string $documentId;
    /** @var string $requestDate The date the Esign was assigned. of yyyy-MM-dd format, IE: 2023-10-04*/
    public string $requestDate;
    /** @var string $accountName The name of the Assignee of the Esign.*/
    public string $accountName;
    /** @var string $accountId The Assignee of the Esign.*/
    public string $accountId;
    /** @var string $displayId The contract's id to display.*/
    public string $displayId;
    /** @var string $previewUrl The url of the preview document.*/
    public string $previewUrl;
    /** @var \Bushelpowered\Api\Trade\Esign\V1\Model\EsignListSignature $signature */
    public \Bushelpowered\Api\Trade\Esign\V1\Model\EsignListSignature $signature;
    /** @var null|string $continuationToken A service-generated token encoding current pagination state. <br>Clients SHOULD NOT attempt to manufacture continuation tokens.*/
    public ?string $continuationToken = null;

    /**
     * @param  string  $documentId The Esign Service's Document Id.
     * @param  string  $requestDate The date the Esign was assigned. of yyyy-MM-dd format, IE: 2023-10-04
     * @param  string  $accountName The name of the Assignee of the Esign.
     * @param  string  $accountId The Assignee of the Esign.
     * @param  string  $displayId The contract's id to display.
     * @param  string  $previewUrl The url of the preview document.
     * @param  \Bushelpowered\Api\Trade\Esign\V1\Model\EsignListSignature  $signature 
     * @param  null|string  $continuationToken A service-generated token encoding current pagination state. <br>Clients SHOULD NOT attempt to manufacture continuation tokens.
     */
    public function __construct(string $documentId, string $requestDate, string $accountName, string $accountId, string $displayId, string $previewUrl, \Bushelpowered\Api\Trade\Esign\V1\Model\EsignListSignature $signature, ?string $continuationToken)
    {
        $this->documentId = $documentId;
        $this->requestDate = $requestDate;
        $this->accountName = $accountName;
        $this->accountId = $accountId;
        $this->displayId = $displayId;
        $this->previewUrl = $previewUrl;
        $this->signature = $signature;
        $this->continuationToken = $continuationToken;
    }
    
    /**
     * @return null|string A service-generated token encoding current pagination state. <br>Clients SHOULD NOT attempt to manufacture continuation tokens.
     */
    public function getContinuationToken(): ?string
    {
        return $this->continuationToken;
    }
}