<?php
namespace Bushelpowered\Api\Trade\Futures\V1\Model;
        
class BidLocationStandard 
{
    /** @var int $locationId The centre id for the Location*/
    public int $locationId;
    /** @var string $bushelLocationId The bushel location id for the Location*/
    public string $bushelLocationId;
    /** @var string $locationName The centre name for the Location*/
    public string $locationName;
    /** @var string $salesSeriesId The sales series id for which the Location belongs*/
    public string $salesSeriesId;
    /** @var \Bushelpowered\Api\Trade\Futures\V1\Model\BidCommodityStandard[] $commodities The commodities tied to the Location*/
    public array $commodities;

    /**
     * @param  int  $locationId The centre id for the Location
     * @param  string  $bushelLocationId The bushel location id for the Location
     * @param  string  $locationName The centre name for the Location
     * @param  string  $salesSeriesId The sales series id for which the Location belongs
     * @param  \Bushelpowered\Api\Trade\Futures\V1\Model\BidCommodityStandard[]  $commodities The commodities tied to the Location
     */
    public function __construct(int $locationId, string $bushelLocationId, string $locationName, string $salesSeriesId, array $commodities)
    {
        $this->locationId = $locationId;
        $this->bushelLocationId = $bushelLocationId;
        $this->locationName = $locationName;
        $this->salesSeriesId = $salesSeriesId;
        $this->commodities = $commodities;
    }
    

}