<?php
namespace Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Find\Dto;
        
class GetDealerResponse 
{
    /** @var string $id */
    public string $id;
    /** @var string $name */
    public string $name;
    /** @var null|string $icon */
    public ?string $icon = null;
    /** @var null|string $banner */
    public ?string $banner = null;
    /** @var \Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Find\Dto\LegalTerm[] $termsAndConditions */
    public array $termsAndConditions;
    /** @var \Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Find\Dto\LoanLinkInitiationMethod[] $loanLinkInitiationMethods */
    public array $loanLinkInitiationMethods;

    /**
     * @param  string  $id 
     * @param  string  $name 
     * @param  null|string  $icon 
     * @param  null|string  $banner 
     * @param  \Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Find\Dto\LegalTerm[]  $termsAndConditions 
     * @param  \Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Find\Dto\LoanLinkInitiationMethod[]  $loanLinkInitiationMethods 
     */
    public function __construct(string $id, string $name, ?string $icon, ?string $banner, array $termsAndConditions, array $loanLinkInitiationMethods)
    {
        $this->id = $id;
        $this->name = $name;
        $this->icon = $icon;
        $this->banner = $banner;
        $this->termsAndConditions = $termsAndConditions;
        $this->loanLinkInitiationMethods = $loanLinkInitiationMethods;
    }
    

}