<?php

namespace Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Find\Dto;

class LoanLinkInitiationMethod
{
    public string $type;
    public $data;
    private \JsonMapper $mapper;

    private static $types = [
        'dynamicInput' => '\Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Find\Dto\DynamicInputLoanLinkInitiationMethod',
    ];

    private function __construct($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function DynamicInput(\Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Find\Dto\DynamicInputLoanLinkInitiationMethod $data): LoanLinkInitiationMethod
    {
        return new LoanLinkInitiationMethod('dynamicInput', $data);
    }

    public function getData() {
        $className = self::$types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    