<?php
namespace Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Findmany;

use \Bushelpowered\Api\Common\Request\EmptyRequest;
use \Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Findmany\Dto\GetDealersResponse;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bidl\Php\Core\Builtins\UnknownError;

class GetDealers 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    /**
     * @deprecated use request instead.
     */
    public function call(EmptyRequest $request, $headers): GetDealersResponse | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/wallet/aggregator/v1/dealers/findmany/GetDealers', $request, $this->getWrapper(), $headers);
    }
    
    public function request(EmptyRequest $request, GetDealersMetadata $hasHeaders): GetDealersResponse | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/wallet/aggregator/v1/dealers/findmany/GetDealers', $request, $this->getWrapper(), $hasHeaders->getMetaData());
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var GetDealersResponse | NotAuthenticated | NotAuthorized | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.wallet.aggregator.v1.dealers.findmany#GetDealersSuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Findmany\Dto\GetDealersResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthenticated':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthorized':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}